<?php
/*
 * @package		Joomla.Framework
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 *
 * @component Google Site Search plugin
 * @copyright Copyright (C) Marcinko Ernest, www.offlajn.com
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License version 2 or later;
 */

/*

  QUICK TROUBLESHOOTING, DONT READ IT IF YOU THINK YOU ARE A GENIUS
  

  If you are reading this, you probably had some trouble setting up the plugin.
  Dont forget to set a valid google api key on the plugin settings page.
  After that, you get 100 free searches each day. If you want more, you
  must pay for google.
  
  Also, you need Curl for this to work. You can check if the plugin exists, by
  creating an empty php file on your server, and adding the following line:
  
  function_exists("curl_init") echo "All right, you have Curl";
  else echo "What a shame, no Curl on this one.";

  What to do if you realize you dont have Curl? Well, you should contact the
  server administrator, to make it work for you, or if you own the server
  then search for the php.ini file, and modify the line
  ;extension=php_curl.dll   
  to
  extension=php_curl.dll
  
  Oh my god, the images of the search results are not showing!!
  Chill dude, it's not the end of the world. It's also a matter of php.ini setting.
  Contact the server admin for allowing the url fopen wrapper, or if you own the server search for:
  allow_url_fopen = Off
  and modify it:
  allow_url_fopen = On
  
  Now, thats it. I hope you enjoy my work.
*/


defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' ) ;

jimport( 'joomla.plugin' ) ;

/** Register search function inside Joomla's API */
$mainframe->registerEvent( 'onSearch', 'onContentSearch' ) ;
$mainframe->registerEvent( 'onSearchAreas', 'onContentSearchAreas' );
/**
 * @return array An array of search areas
 */
function &onContentSearchAreas() {
	static $areas = array(
		'googlesitesearch' => 'Google Search'
		);
		return $areas;
}

function onContentSearch( $text, $phrase = '', $ordering = '', $areas=null  ) {
    global $sess;
  	$plugin = &JPluginHelper::getPlugin('search', 'googlesitesearch');
  	$pluginParams = new JParameter($plugin->params);
  	
		if (is_array( $areas )) {
			if (!array_intersect($areas, array_keys(onContentSearchAreas()))) {
				return array();
			}
		}
		
		$limit = $pluginParams->get('search_limit', 10);
		$api_key = $pluginParams->get('api_key');
		if ($api_key=="")
		 return array();
		$search_site = ($pluginParams->get('search_site')==1)?" site:".JURI::root():"";

		$text = trim( $text );
		if ($text == '') {
			return array();
		}
		
     $sugg = "";
     if(function_exists("curl_init") && curl_init("http://google.com")!==false) {
      $curl = curl_init("https://www.googleapis.com/customsearch/v1?key=".$api_key."&cx=013036536707430787589:_pqjad5hr1a&alt=json&q=".urlencode($text.$search_site));
      /*
       Setting the transfer from the stdout to a variable, and allowing an ssl connection.
      */
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
      $r = curl_exec ($curl);
      curl_close ($curl);
     } else 
      return array();
     
     $res = json_decode($r, true);
     $rows = array();
     $i = 1;

     if (isset($res['items']))
       foreach ($res['items'] as $item) {
          if ($i>=$limit) break;
          $one = new StdClass();
          $one->title = $item['title'];
          $one->text = $item['snippet'];
          $one->href = $item['link'];
          /*
            Check if image exists and the allow_url_fopen is set to on in php.ini.
          */
          if (isset($item['pagemap']['cse_image']) && @file_get_contents($item['pagemap']['cse_image'][0]['src'])!==false) 
            $one->image = $item['pagemap']['cse_image'][0]['src'];
          $rows[] = $one;
          $one = null;
       }
    ob_start();
    ob_end_clean();		
		return $rows;
}
?>